#include <Adafruit_AM2320.h>

#include <MQ135.h>

#include <MQUnifiedsensor.h>
#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>
#include <Wire.h>
#include <SFE_BMP180.h>
#include "MQ135.h"

boolean backlight = true;
int contrast=50;
int menuitem = 1;
int page = 1;

volatile boolean back = false;
volatile boolean down = false;
volatile boolean middle = false;

int sensorValueGas;
const int ANALOGPIN0=0;
MQ135 gasSensor = MQ135(ANALOGPIN0);
float gasValue;
double T, P;
SFE_BMP180 bmp180;
Adafruit_AM2320 humiditySensor = Adafruit_AM2320();
float humidityValue;

int downButtonState = 0;
int backButtonState = 0;  
int selectButtonState = 0;          
int lastDownButtonState = 0;
int lastSelectButtonState = 0;
int lastBackButtonState = 0;

Adafruit_PCD8544 display = Adafruit_PCD8544( 5, 4, 3);
void setup() {
  pinMode(2, INPUT_PULLUP);
  pinMode(1, INPUT_PULLUP);
  pinMode(0, INPUT_PULLUP);
  pinMode(7,OUTPUT);
  digitalWrite(7,LOW); //Turn Backlight ON
  
  Serial.begin(9600);
  bmp180.begin();
  humiditySensor.begin();
  
  display.begin();      
  display.setContrast(contrast); //Set contrast to 50
  display.clearDisplay(); 
  display.display();   
}
void loop() {
  drawMenu();
  downButtonState = digitalRead(2);
  selectButtonState = digitalRead(1);
  backButtonState =   digitalRead(0);
 
  checkIfDownButtonIsPressed();
  checkIfBackButtonIsPressed();
  checkIfSelectButtonIsPressed();

  if (back && page == 1) {
    back = false;
    menuitem = 1;
    page = 1;
  }
  else if (back && page == 2 ) {
    back = false;
    menuitem = 1;
    page = 1;    
  }else if (back && page == 3 ) {
    back = false;
    contrast--;
    setContrast();
  } else if (back && page == 4) {
    back = false;
    page = 1;
    menuitem = 1;
  } else if (back && (page == 5 || page == 6 || page == 7)) {
    menuitem = 1;
    back = false;
    page = 4;
  }

  if (down && page == 1) {
    down = false;
    menuitem ++;
    if (menuitem == 3) {
      menuitem = 1;
    }
  }
  if (down && page == 2) {
    down = false;
    menuitem++;
    if (menuitem==4) 
    {
      menuitem=1;
    }      
  }else if (down && page == 3 ) {
    down = false;
    contrast++;
    setContrast();
  } else if (down && page == 4) {
    down = false;
    menuitem++;
    if (menuitem==4) 
    {
      menuitem=1;
    }      
  }
  if (middle) {
    middle = false;
    
    if (page == 2 && menuitem==2) 
    {
      if (backlight) 
      {
        backlight = false;
        turnBacklightOff();
        }
      else 
      {
        backlight = true; 
        turnBacklightOn();
       }
    }
    if (page == 1 && menuitem== 1) {
      page = 4;     
    }
    else if (page == 1 && menuitem == 2) {
      page = 2;
      menuitem = 1;
    }
    else if(page == 2 && menuitem ==3)
    {
      resetDefaults();
    }
else if (page == 2 && menuitem==1) {
      page=3;
     }
else if (page == 3) {
      page=2;
     } 
     else if (page == 4) {
      if (menuitem == 1) {
         page = 5; 
         getTempAndPressure();
         humidityValue = humiditySensor.readHumidity();
         Serial.print("Humidity: "); Serial.print(humidityValue);
         Serial.print("Temperature: "); Serial.println(T); 
         menuitem = 1;
      } else if (menuitem == 2) {
        page = 6;  
        getTempAndPressure();
        Serial.print("Pressure: "); Serial.println(P);
        menuitem = 1;
      } else if (menuitem == 3) {
        page = 7;
        menuitem = 1;
        readGasData();
        delay(100);
      }
     }
   }
   
  }
  void checkIfDownButtonIsPressed()
  {
    if (downButtonState != lastDownButtonState) 
  {
    if (downButtonState == 0) 
    {
      down=true;
    }
    delay(30);
  }
   lastDownButtonState = downButtonState;
  }
void checkIfBackButtonIsPressed()
{
  if (backButtonState != lastBackButtonState) 
  {
    if (backButtonState == 0) {
      back=true;
    }
    delay(50);
  }
   lastBackButtonState = backButtonState;
}
void checkIfSelectButtonIsPressed()
{
   if (selectButtonState != lastSelectButtonState) 
  {
    if (selectButtonState == 0) {
      middle=true;
    }
    delay(50);
  }
   lastSelectButtonState = selectButtonState;
}
  
  void drawMenu()
  {

  if (page == 1){
    display.setTextSize(1);
    display.clearDisplay();
    display.setTextColor(BLACK, WHITE);
    display.setCursor(15, 0);
    display.print("MAIN MENU");
    display.drawFastHLine(0,10,83,BLACK);
    display.setCursor(0, 15);

    displaySelected(1);
    display.print(">Data Manager");
    display.setCursor(0, 25);
    
    displaySelected(2);
    display.print(">Settings");

    display.display();
  }
  else if (page==2) 
  {    
    display.setTextSize(1);
    display.clearDisplay();
    display.setTextColor(BLACK, WHITE);
    display.setCursor(15, 0);
    display.print("SETTINGS");
    display.drawFastHLine(0,10,83,BLACK);
    display.setCursor(0, 15);
   
    displaySelected(1);
    display.print(">Contrast");
    display.setCursor(0, 25);
   
    displaySelected(2);
    display.print(">Light: ");
    
    if (backlight) 
    {
      display.print("ON");
    }
    else 
    {
      display.print("OFF");
    }
    display.display();
    
    displaySelected(3);
    display.setCursor(0, 35);
    display.print(">Reset");
    display.display();
  }
    
 
  else if (page==3) 
  {
    
    display.setTextSize(1);
    display.clearDisplay();
    display.setTextColor(BLACK, WHITE);
    display.setCursor(15, 0);
    display.print("CONTRAST");
    display.drawFastHLine(0,10,83,BLACK);
    display.setCursor(5, 15);
    display.print("Value");
    display.setTextSize(2);
    display.setCursor(5, 25);
    display.print(contrast);
 
    display.setTextSize(2);
    display.display();
  } else if (page == 4) {
    
    display.setTextSize(1);
    display.clearDisplay();
    display.setTextColor(BLACK, WHITE);
    display.setCursor(15, 0);
    display.print("DATA SET");
    display.drawFastHLine(0,10,83,BLACK);
    display.setCursor(0, 15);

    displaySelected(1);
    display.print(">Temp&Humidity");
    display.setCursor(0, 25);
    
    displaySelected(2);
    display.print(">Pressure");
    display.setCursor(0, 35);

    displaySelected(3);
    display.print(">Gas");

    display.display();
  }else if (page == 5) {
    display.setTextSize(1);
    display.clearDisplay();
    display.setTextColor(BLACK, WHITE);
    display.setCursor(0, 5);
    display.print("Temperature:");
    display.setCursor(0,15);
    display.print(T);display.print(" *C");
    display.setCursor(0, 25);
    display.print("Humidity:");
    display.setCursor(0, 35);
    display.print(humidityValue); display.print("%");
    display.display();
  } else if (page == 6) {
    display.setTextSize(1);
    display.clearDisplay();
    display.setTextColor(BLACK, WHITE);
    display.setCursor(0, 0);
    display.print("Pressure:");
    display.setCursor(0, 25);
    display.print(P);
    display.print(" hPa");
    display.display();
  } else if (page == 7) {
    display.setTextSize(1);
    display.clearDisplay();
    display.setTextColor(BLACK, WHITE);
    display.setCursor(0, 5);
    display.print("Gas:");
    display.setCursor(0, 15);
    display.print(sensorValueGas, DEC); display.print(" ppm");
    display.setCursor(0, 25);
    if (sensorValueGas >= 400 && sensorValueGas <= 750) {
      display.print("GOOD");
    } else if (sensorValueGas > 750 && sensorValueGas <= 1200) {
      display.print("Take care!");
    } else if (sensorValueGas > 1200) {
      display.print("BAD");
    }

    delay(100);
    display.display();
  }
  
  }
  void resetDefaults()
  {
    contrast = 50;
    setContrast();
    backlight = true;
    turnBacklightOn();
  }
  void setContrast()
  {
    display.setContrast(contrast);
    display.display();
  }
  void turnBacklightOn()
  {
    digitalWrite(7,LOW);
  }
    void turnBacklightOff()
  {
    digitalWrite(7,HIGH);
  }


  void displaySelected(int menuItemSelected) {
    if (menuitem == menuItemSelected) {
      display.setTextColor(WHITE, BLACK); 
    }
    else {
      display.setTextColor(BLACK, WHITE);
    }
  }


 void getTempAndPressure() {
  char status;
  bool success = false;

  status = bmp180.startTemperature();

  if (status != 0) {
    delay(1000);
    status = bmp180.getTemperature(T);

    if (status != 0) {
      status = bmp180.startPressure(3);

      if (status != 0) {
        delay(status);
        status = bmp180.getPressure(P, T);
      } else {
        T = -1000;
        P = -1000;
      }
    } else {
      T = -1000;
      P = -1000;
    }
  } else {
    T = -1000;
    P = -1000;
  }
 }

 void readGasData() {
    sensorValueGas = analogRead(0);
    delay(100);
    Serial.print("Gas: ");Serial.println(sensorValueGas, DEC);
    delay(100);
 }
