import serial
import requests
import re


def get_data(pressure=-1000., gas=-1000., temp=-1000., humidity=-1000.):
    data = {}
    data.update({"pressure": pressure})
    data.update({"temp": temp})
    data.update({"gas_ppm": gas})
    data.update({"humidity": humidity})
    return data


s = serial.Serial(port='COM4', baudrate=9600, timeout=.1)
while True:
    return_value = s.readline()
    res = return_value.decode()
    if res.find("Temperature") >= 0 and len(res) > len("Temperature") \
            or res.find("Humidity") >= 0 and len(res) > len("Humidity"):
        temp = re.findall('Temperature: [0-9]+[.]*[0-9]*', res)
        humidity = re.findall('Humidity: [0-9]+[.]*[0-9]*', res)

        temp_value = re.findall('[0-9]+[.]*[0-9]*', str(temp))
        humidity_value = re.findall('[0-9]+[.]*[0-9]*', str(humidity))

        requests.post('http://127.0.0.1:8080/', data=get_data(temp=float(temp_value[0]), humidity=float(humidity_value[0])))
    elif res.find("Pressure") >= 0 and len(res) > len("Pressure"):
        pressure = re.findall('[0-9]+[.]*[0-9]*', res)
        requests.post('http://127.0.0.1:8080/', data=get_data(pressure=float(pressure[0])))
    elif res.find("Gas") >= 0 and len(res) > len("Gas"):
        gas = re.findall('[0-9]+[.]*[0-9]*', res)
        requests.post('http://127.0.0.1:8080/', data=get_data(gas=float(gas[0])))
